using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserRole;
namespace CMSMicroservice.Protobuf.Validator.UserRole;

public class GetUserRoleRequestValidator : AbstractValidator<GetUserRoleRequest>
{
    public GetUserRoleRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetUserRoleRequest>.CreateWithOptions((GetUserRoleRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
